(Vcoding_system_alist): Deleted.
[bpt/emacs.git] / make-dist
index 19082f2..67aaffe 100755 (executable)
--- a/make-dist
+++ b/make-dist
@@ -21,8 +21,9 @@
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with GNU Emacs; see the file COPYING.  If not, write to
-# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+# along with GNU Emacs; see the file COPYING.  If not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
 
 progname="$0"
 
@@ -32,23 +33,28 @@ progname="$0"
 ### Print out each line we read, for debugging's sake.
 ### set -v
 
-clean_up=yes
-make_tar=yes
+## Don't protect any files.
+umask 0
+
+update=yes
+clean_up=no
+make_tar=no
 newer=""
 
 while [ $# -gt 0 ]; do
   case "$1" in
-    ## This option tells make-dist not to delete the staging directory
-    ## after it's done making the tar file.
-    "--no-clean-up" )
-      clean_up=no
+    ## This option tells make-dist to delete the staging directory
+    ## when done.  It is useless to use this unless you make a tar file.
+    "--clean-up" )
+      clean_up=yes
+    ;;
+    ## This option tells make-dist to make a tar file.
+    "--tar" )
+      make_tar=yes
     ;;
-    ## This option tells make-dist not to make a tar file.  Since it's 
-    ## rather pointless to build the whole staging directory and then
-    ## nuke it, using this option also selects '--no-clean-up'.
-    "--no-tar" )
-      make_tar=no
-      clean_up=no
+    ## This option tells make-dist not to recompile or do analogous things.
+    "--no-update" )
+      update=no
     ;;
     ## This option tells make-dist to make the distribution normally, then
     ## remove all files older than the given timestamp file.  This is useful
@@ -79,6 +85,21 @@ if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
   exit 1
 fi
 
+### Find where to run Emacs.
+if [ $update = yes ];
+then
+  if [ -f src/emacs ];
+  then
+    EMACS=`pwd`/src/emacs
+  else
+    if [ x$EMACS = x ];
+    then 
+      echo You must specify the EMACS environment variable 2>&1
+      exit 1
+    fi
+  fi
+fi
+
 ### Find out which version of Emacs this is.
 shortversion=`grep 'defconst[   ]*emacs-version' lisp/version.el \
         | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\).*$/\1/'`
@@ -91,11 +112,14 @@ fi
 
 echo Version numbers are $version and $shortversion
 
-if grep -s "GNU Emacs version ${shortversion}" ./man/emacs.texi > /dev/null; then
-  true
-else
-  echo "You must update the version number in \`./man/emacs.texi'"
-  sleep 5
+if [ $update = yes ];
+then
+  if grep -s "GNU Emacs version ${shortversion}" ./man/emacs.texi > /dev/null; then
+    true
+  else
+    echo "You must update the version number in \`./man/emacs.texi'"
+    sleep 5
+  fi
 fi
 
 ### Make sure we don't already have a directory  emacs-${version}.
@@ -120,8 +144,8 @@ them, and try again." >&2
 fi
 
 ### Check for .elc files with no corresponding .el file.
-ls -1 lisp/*.el | sed 's/\.el$/.elc/' > /tmp/el
-ls -1 lisp/*.elc > /tmp/elc
+ls -1 lisp/[a-z]*.el | sed 's/\.el$/.elc/' > /tmp/el
+ls -1 lisp/[a-z]*.elc > /tmp/elc
 bogosities="`comm -13 /tmp/el /tmp/elc`"
 if [ "${bogosities}" != "" ]; then
   echo "The following .elc files have no corresponding .el files:"
@@ -129,6 +153,28 @@ if [ "${bogosities}" != "" ]; then
 fi
 rm -f /tmp/el /tmp/elc
 
+### Check for .el files with no corresponding .elc file.
+(cd lisp; ls -1 [a-z]*.el) > /tmp/el
+(cd lisp; ls -1 [a-z]*.elc) | sed 's/\.elc$/.el/' > /tmp/elc
+losers="`comm -23 /tmp/el /tmp/elc`"
+for file in $losers; do
+  if ! grep -q "dontcompilefiles:.* $file\($\| \)" lisp/Makefile; then
+    bogosities="$file $bogosities"
+  fi
+done
+if [ "${bogosities}" != "" ]; then
+  echo "The following .elc files have no corresponding .el files:"
+  echo "${bogosities}"
+fi
+rm -f /tmp/el /tmp/elc
+
+### Check for .el files that would overflow the 14-char limit if compiled.
+long=`find lisp -name '[a-zA-Z0-9]??????????*.el' -print`
+if [ "$long" != "" ]; then
+  echo "The following .el file names are too long:"
+  echo "$long"
+fi
+
 ### Make sure configure is newer than configure.in.
 if [ "x`ls -t configure configure.in | head -1`" != "xconfigure" ]; then
   echo "\`./configure.in' is newer than \`./configure'" >&2
@@ -136,24 +182,20 @@ if [ "x`ls -t configure configure.in | head -1`" != "xconfigure" ]; then
   autoconf || { x=$?; echo Autoconf FAILED! >&2; exit $x; }
 fi
 
-### Update getdate.c.
-(cd lib-src; make -f Makefile getdate.c YACC="bison -y")
-
-echo "Updating Info files"
-
-(cd man; make info)
-
-echo "Updating finder-inf.el"
+if [ $update = yes ];
+then
+  echo "Updating Info files"
 
-(cd lisp; ../src/emacs -batch -l finder -f finder-compile-keywords-make-dist)
+  (cd man; make info)
 
-echo "Recompiling Lisp files"
+  echo "Recompiling Lisp files"
 
-src/emacs -batch -f batch-byte-recompile-directory lisp
+  $EMACS -batch -f batch-byte-recompile-directory lisp
 
-echo "Updating autoloads"
+  echo "Updating finder, custom and autoload data"
 
-src/emacs -batch -f batch-update-autoloads lisp
+  (cd lisp; make updates)
+fi
 
 echo "Making lisp/MANIFEST"
 
@@ -197,14 +239,14 @@ echo "Updating version number in README"
 
 
 echo "Creating subdirectories"
-for subdir in lisp lisp/term site-lisp \
+for subdir in lisp site-lisp \
              src src/m src/s src/bitmaps lib-src oldXMenu lwlib \
-             nt nt/inc nt/inc/sys \
+             nt nt/inc nt/inc/sys nt/inc/arpa nt/inc/netinet \
              etc etc/e lock cpp info man msdos vms; do
   mkdir ${tempdir}/${subdir}
 done
 
-echo "Making links to \`lisp'"
+echo "Making links to \`lisp' and its subdirectories"
 ### Don't distribute TAGS, =*.el files, site-init.el, site-load.el, or default.el.
 (cd lisp
  ln [a-zA-Z]*.el ../${tempdir}/lisp
@@ -213,47 +255,67 @@ echo "Making links to \`lisp'"
  ## simula.el doesn't keep abbreviations in simula.defns any more.
  ## ln [a-zA-Z]*.defns ../${tempdir}/lisp
  ln ChangeLog Makefile makefile.nt ChangeLog.? README ../${tempdir}/lisp
- cd ../${tempdir}/lisp
- rm -f TAGS =*
- rm -f subdirs.el
- rm -f site-init site-init.el site-init.elc
- rm -f site-load site-load.el site-load.elc
- rm -f site-start site-start.el site-start.elc
- rm -f default default.el default.elc)
-
-#echo "Making links to \`lisp/calc-2.02'"
-#### Don't distribute =*.el files, TAGS or backups.
-#(cd lisp/calc-2.02
-# ln [a-zA-Z]*.el ../../${tempdir}/lisp/calc-2.02
-# ln [a-zA-Z]*.elc ../../${tempdir}/lisp/calc-2.02
-# ln calc.info* calc.texinfo calc-refcard.* ../../${tempdir}/lisp/calc-2.02
-# ln INSTALL Makefile README README.prev ../../${tempdir}/lisp/calc-2.02
-# cd ../../${tempdir}/lisp/calc-2.02
-# rm -f *~ TAGS)
-
-echo "Making links to \`lisp/term'"
-### Don't distribute =*.el files or TAGS.
-(cd lisp/term
- ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
- ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
- ln README ../../${tempdir}/lisp/term
- rm -f =* TAGS)
+ (cd ../${tempdir}/lisp
+  rm -f TAGS =*
+  rm -f site-init site-init.el site-init.elc
+  rm -f site-load site-load.el site-load.elc
+  rm -f site-start site-start.el site-start.elc
+  rm -f default default.el default.elc
+  )
+
+ ## Find all subdirs of lisp dir
+ for file in `find . -type d -print`; do
+   case $file in
+     . | .. | */Old | */RCS)
+       ;;      
+     *)
+       if [ -d $file ]; then
+        subdirs="$file $subdirs"
+       fi
+       ;;
+   esac
+ done
+
+ for file in $subdirs; do
+   echo "  lisp/$file"
+   mkdir ../${tempdir}/lisp/$file
+   ln $file/[a-zA-Z]*.el ../${tempdir}/lisp/$file
+   ln $file/[a-zA-Z]*.elc ../${tempdir}/lisp/$file
+   if [ -f $file/README ]; then
+     ln $file/README ../${tempdir}/lisp/$file
+   fi
+   rm -f $file/=* $file/TAGS
+ done )
 
 echo "Making links to \`src'"
 ### Don't distribute =*.[ch] files, or the configured versions of
 ### config.in, paths.in, or Makefile.in, or TAGS.
 (cd src
- echo "  (If we can't link gmalloc.c, that's okay.)"
+ echo "  (It is ok if ln fails in some cases.)"
  ln [a-zA-Z]*.c ../${tempdir}/src
- ## Might be a symlink to a file on another filesystem.
- test -f ../${tempdir}/src/gmalloc.c || cp gmalloc.c ../${tempdir}/src
  ln [a-zA-Z]*.h ../${tempdir}/src
  ln [a-zA-Z]*.s ../${tempdir}/src
- ln README Makefile.in ChangeLog ChangeLog.? config.in paths.in \
-    ../${tempdir}/src
- ln makefile.nt ../${tempdir}/src
+ ln [a-zA-Z]*.in ../${tempdir}/src
+ ln [a-zA-Z]*.opt ../${tempdir}/src
+ ## If we ended up with a symlink, or if we did not get anything
+ ## due to a cross-device symlink, copy the file.
+ for file in [a-zA-Z]*.[hcs] [a-zA-Z]*.in [a-zA-Z]*.opt; do
+   if test -f ../${tempdir}/src/$file; then
+     # test -f appears to succeed for a symlink
+     if test -L ../${tempdir}/src/$file; then
+       rm ../${tempdir}/src/$file
+       cp $file ../${tempdir}/src
+       chmod a-w ../${tempdir}/src/$file
+     fi
+   else
+     rm ../${tempdir}/src/$file
+     cp $file ../${tempdir}/src
+     chmod a-w ../${tempdir}/src/$file
+   fi
+ done
+ ln README ChangeLog ChangeLog.*[0-9] ../${tempdir}/src
+ ln makefile.nt vms-pp.trans ../${tempdir}/src
  ln .gdbinit .dbxinit ../${tempdir}/src
- ln *.opt vms-pp.trans ../${tempdir}/src
  cd ../${tempdir}/src
  rm -f config.h paths.h Makefile Makefile.c
  rm -f =* TAGS)
@@ -276,13 +338,29 @@ echo "Making links to \`lib-src'"
  ln [a-zA-Z]*.[chy] ../${tempdir}/lib-src
  ln ChangeLog Makefile.in README testfile vcdiff ../${tempdir}/lib-src
  ln emacs.csh rcs2log rcs-checkin makefile.nt ../${tempdir}/lib-src
+ ## If we ended up with a symlink, or if we did not get anything
+ ## due to a cross-device symlink, copy the file.
+ for file in [a-zA-Z]*.[chy]; do
+   if test -f ../${tempdir}/lib-src/$file; then
+     # test -f appears to succeed for a symlink
+     if test -L ../${tempdir}/lib-src/$file; then
+       rm ../${tempdir}/lib-src/$file
+       cp $file ../${tempdir}/lib-src
+       chmod a-w ../${tempdir}/lib-src/$file
+     fi
+   else
+     rm ../${tempdir}/lib-src/$file
+     cp $file ../${tempdir}/lib-src
+     chmod a-w ../${tempdir}/lib-src/$file
+   fi
+ done
  cd ../${tempdir}/lib-src
- rm -f getdate.tab.c y.tab.c y.tab.h Makefile.c
+ rm -f Makefile.c
  rm -f =* TAGS)
 
 echo "Making links to \`nt'"
 (cd nt
- ln emacs.ico emacs.rc config.nt config.w95 [a-z]*.in [a-z]*.c ../${tempdir}/nt
+ ln emacs.ico emacs.rc config.nt [a-z]*.in [a-z]*.c ../${tempdir}/nt
  ln [a-z]*.bat [a-z]*.h makefile.def makefile.nt ../${tempdir}/nt
  ln TODO ChangeLog INSTALL README ../${tempdir}/nt)
 
@@ -294,10 +372,18 @@ echo "Making links to \`nt/inc/sys'"
 (cd nt/inc/sys
  ln [a-z]*.h ../../../${tempdir}/nt/inc/sys)
 
+echo "Making links to \`nt/inc/arpa'"
+(cd nt/inc/arpa
+ ln [a-z]*.h ../../../${tempdir}/nt/inc/arpa)
+
+echo "Making links to \`nt/inc/netinet'"
+(cd nt/inc/netinet
+ ln [a-z]*.h ../../../${tempdir}/nt/inc/netinet)
+
 echo "Making links to \`msdos'"
 (cd msdos
  ln  ChangeLog emacs.ico emacs.pif ../${tempdir}/msdos
- ln mainmake sed*.inp ../${tempdir}/msdos
+ ln is_exec.c sigaction.c mainmake mainmake.v2 sed*.inp ../${tempdir}/msdos
  cd ../${tempdir}/msdos
  rm -f =*)